#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/io.h>
#include <linux/input.h>
#include <linux/fs.h>
#include <linux/clk.h>
#include <linux/hid.h>
#include <linux/delay.h>
#include <linux/vmalloc.h>
#include <linux/platform_device.h>
#include <linux/input-polldev.h>

#include <mach/mx28.h>
#include <mach/clock.h>
#include <mach/regs-timrot.h>
#include <../regs-clkctrl.h>

#ifdef	MODVERSIONS
#include <linux/modversions.h>
#endif

#include <asm/uaccess.h>
#include <asm/io.h>

#include "drvtimrot.h"

#undef	RELATIVE
#define CLKCTRL_BASE_ADDR IO_ADDRESS(CLKCTRL_PHYS_ADDR)

MODULE_AUTHOR("B31117");
MODULE_DESCRIPTION("rotary decoder driver");
MODULE_LICENSE("GPL");
MODULE_VERSION("1.0");

static u32 *mx28_timer_base;

// local static function prototypes
static int  drvtimrot_init(void);
static void drvtimrot_exit(void);

static int __init drvtimrot_init(void)
{
	int result = 0;
	u32 reg;
	//u32 * mx28_iomux_base;

	printk(KERN_INFO "%s: [begin]\n",__func__);

	//mx28_iomux_base = IO_ADDRESS(PINCTRL_PHYS_ADDR);
	mx28_timer_base = IO_ADDRESS(TIMROT_PHYS_ADDR);

	//reg =  __raw_readl(IO_ADDRESS(PINCTRL_PHYS_ADDR + HW_PINCTRL_MUXSEL7));
	//printk(KERN_INFO "%s: iomuxsel7  = %08x\n",__func__,reg);

	reg = __raw_readl(IO_ADDRESS(TIMROT_PHYS_ADDR + HW_TIMROT_ROTCTRL) );
	printk(KERN_INFO "%s: rotctrl  = %08x\n",__func__,reg);


	//reg = *(mx28_timer_base + HW_TIMROT_ROTCOUNT);
	reg = __raw_readl(IO_ADDRESS(TIMROT_PHYS_ADDR + HW_TIMROT_ROTCOUNT) );
	printk(KERN_INFO "%s: rotcount = %08x\n",__func__,reg);

	reg = __raw_readl(CLKCTRL_BASE_ADDR + HW_CLKCTRL_XBUS);
	printk(KERN_INFO "%s: clkctrl_xbus = %08x\n",__func__,reg);

	reg = __raw_readl(CLKCTRL_BASE_ADDR + HW_CLKCTRL_XTAL);
	printk(KERN_INFO "%s: clkctrl_xtal = %08x\n",__func__,reg);

	printk(KERN_INFO "%s: [done]\n",__func__);
	return result;
}

static void __exit drvtimrot_exit(void)
{
	u32 reg;

	reg = __raw_readl(mx28_timer_base + HW_TIMROT_ROTCTRL);
	printk(KERN_INFO "%s: rotctrl  = %08x\n",__func__,reg);

	reg = __raw_readl(mx28_timer_base + HW_TIMROT_ROTCOUNT);
	printk(KERN_INFO "%s: rotcount = %08x\n",__func__,reg);

	printk(KERN_INFO "%s: [begin]\n",__func__);
	printk(KERN_INFO "%s: [done]\n",__func__);
	return;
}

module_init(drvtimrot_init);
module_exit(drvtimrot_exit);

